// Generated by rstantools.  Do not edit by hand.

/*
    prome is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    prome is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with prome.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_ate_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 43> locations_array__ =
  {" (found before start of program)",
  " (in 'ate', line 11, column 2 to column 29)",
  " (in 'ate', line 12, column 2 to column 29)",
  " (in 'ate', line 13, column 2 to column 20)",
  " (in 'ate', line 14, column 2 to column 11)",
  " (in 'ate', line 15, column 2 to column 14)",
  " (in 'ate', line 16, column 2 to column 19)",
  " (in 'ate', line 17, column 2 to column 19)",
  " (in 'ate', line 18, column 2 to column 20)",
  " (in 'ate', line 21, column 2 to column 17)",
  " (in 'ate', line 22, column 2 to column 16)",
  " (in 'ate', line 38, column 2 to column 14)",
  " (in 'ate', line 39, column 2 to column 14)",
  " (in 'ate', line 40, column 2 to column 11)",
  " (in 'ate', line 41, column 2 to column 11)",
  " (in 'ate', line 24, column 4 to column 64)",
  " (in 'ate', line 25, column 4 to column 52)",
  " (in 'ate', line 23, column 15 to line 26, column 3)",
  " (in 'ate', line 23, column 2 to line 26, column 3)",
  " (in 'ate', line 42, column 2 to column 14)",
  " (in 'ate', line 43, column 2 to column 20)",
  " (in 'ate', line 44, column 2 to column 17)",
  " (in 'ate', line 45, column 2 to column 22)",
  " (in 'ate', line 29, column 2 to column 34)",
  " (in 'ate', line 30, column 2 to column 26)",
  " (in 'ate', line 31, column 2 to column 28)",
  " (in 'ate', line 32, column 2 to column 31)",
  " (in 'ate', line 33, column 2 to column 27)",
  " (in 'ate', line 34, column 2 to column 27)",
  " (in 'ate', line 35, column 2 to column 23)",
  " (in 'ate', line 2, column 2 to column 17)",
  " (in 'ate', line 3, column 9 to column 10)",
  " (in 'ate', line 3, column 2 to column 14)",
  " (in 'ate', line 4, column 9 to column 10)",
  " (in 'ate', line 4, column 2 to column 16)",
  " (in 'ate', line 5, column 9 to column 10)",
  " (in 'ate', line 5, column 2 to column 15)",
  " (in 'ate', line 6, column 2 to column 21)",
  " (in 'ate', line 7, column 2 to column 10)",
  " (in 'ate', line 8, column 2 to column 13)",
  " (in 'ate', line 13, column 9 to column 14)",
  " (in 'ate', line 21, column 9 to column 10)",
  " (in 'ate', line 22, column 9 to column 10)"};
#include <stan_meta_header.hpp>
class model_ate final : public model_base_crtp<model_ate> {
private:
  int N;
  Eigen::Matrix<double,-1,1> w_data__;
  Eigen::Matrix<double,-1,1> arm_data__;
  Eigen::Matrix<double,-1,1> tm_data__;
  int nsubj;
  double mu;
  double sigma;
  Eigen::Map<Eigen::Matrix<double,-1,1>> w{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> arm{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> tm{nullptr, 0};
public:
  ~model_ate() {}
  model_ate(stan::io::var_context& context__, unsigned int random_seed__ = 0,
            std::ostream* pstream__ = nullptr) : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_ate_namespace::model_ate";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 30;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 30;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 30;
      stan::math::check_greater_or_equal(function__, "N", N, 1);
      current_statement__ = 31;
      stan::math::validate_non_negative_index("w", "N", N);
      current_statement__ = 32;
      context__.validate_dims("data initialization", "w", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      w_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                   std::numeric_limits<double>::quiet_NaN());
      new (&w) Eigen::Map<Eigen::Matrix<double,-1,1>>(w_data__.data(), N);
      {
        std::vector<local_scalar_t__> w_flat__;
        current_statement__ = 32;
        w_flat__ = context__.vals_r("w");
        current_statement__ = 32;
        pos__ = 1;
        current_statement__ = 32;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 32;
          stan::model::assign(w, w_flat__[(pos__ - 1)],
            "assigning variable w", stan::model::index_uni(sym1__));
          current_statement__ = 32;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 33;
      stan::math::validate_non_negative_index("arm", "N", N);
      current_statement__ = 34;
      context__.validate_dims("data initialization", "arm", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      arm_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                     std::numeric_limits<double>::quiet_NaN());
      new (&arm) Eigen::Map<Eigen::Matrix<double,-1,1>>(arm_data__.data(), N);
      {
        std::vector<local_scalar_t__> arm_flat__;
        current_statement__ = 34;
        arm_flat__ = context__.vals_r("arm");
        current_statement__ = 34;
        pos__ = 1;
        current_statement__ = 34;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 34;
          stan::model::assign(arm, arm_flat__[(pos__ - 1)],
            "assigning variable arm", stan::model::index_uni(sym1__));
          current_statement__ = 34;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 35;
      stan::math::validate_non_negative_index("tm", "N", N);
      current_statement__ = 36;
      context__.validate_dims("data initialization", "tm", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      tm_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                    std::numeric_limits<double>::quiet_NaN());
      new (&tm) Eigen::Map<Eigen::Matrix<double,-1,1>>(tm_data__.data(), N);
      {
        std::vector<local_scalar_t__> tm_flat__;
        current_statement__ = 36;
        tm_flat__ = context__.vals_r("tm");
        current_statement__ = 36;
        pos__ = 1;
        current_statement__ = 36;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 36;
          stan::model::assign(tm, tm_flat__[(pos__ - 1)],
            "assigning variable tm", stan::model::index_uni(sym1__));
          current_statement__ = 36;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 37;
      context__.validate_dims("data initialization", "nsubj", "int",
        std::vector<size_t>{});
      nsubj = std::numeric_limits<int>::min();
      current_statement__ = 37;
      nsubj = context__.vals_i("nsubj")[(1 - 1)];
      current_statement__ = 37;
      stan::math::check_greater_or_equal(function__, "nsubj", nsubj, 1);
      current_statement__ = 38;
      context__.validate_dims("data initialization", "mu", "double",
        std::vector<size_t>{});
      mu = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 38;
      mu = context__.vals_r("mu")[(1 - 1)];
      current_statement__ = 39;
      context__.validate_dims("data initialization", "sigma", "double",
        std::vector<size_t>{});
      sigma = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 39;
      sigma = context__.vals_r("sigma")[(1 - 1)];
      current_statement__ = 40;
      stan::math::validate_non_negative_index("mui", "nsubj", nsubj);
      current_statement__ = 41;
      stan::math::validate_non_negative_index("muii", "N", N);
      current_statement__ = 42;
      stan::math::validate_non_negative_index("sii", "N", N);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = 1 + 1 + nsubj + 1 + 1 + 1 + 1 + 1;
  }
  inline std::string model_name() const final {
    return "model_ate";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ = "model_ate_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      local_scalar_t__ p0 = DUMMY_VAR__;
      current_statement__ = 1;
      p0 = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(-1,
             1, lp__);
      local_scalar_t__ p1 = DUMMY_VAR__;
      current_statement__ = 2;
      p1 = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(-1,
             1, lp__);
      Eigen::Matrix<local_scalar_t__,-1,1> mui =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(nsubj, DUMMY_VAR__);
      current_statement__ = 3;
      mui = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(nsubj);
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = in__.template read<local_scalar_t__>();
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = in__.template read<local_scalar_t__>();
      local_scalar_t__ sa = DUMMY_VAR__;
      current_statement__ = 6;
      sa = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      local_scalar_t__ ss = DUMMY_VAR__;
      current_statement__ = 7;
      ss = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      local_scalar_t__ tau = DUMMY_VAR__;
      current_statement__ = 8;
      tau = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
              lp__);
      Eigen::Matrix<local_scalar_t__,-1,1> muii =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N, DUMMY_VAR__);
      Eigen::Matrix<local_scalar_t__,-1,1> sii =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N, DUMMY_VAR__);
      current_statement__ = 18;
      for (int i = 1; i <= N; ++i) {
        current_statement__ = 15;
        stan::model::assign(muii,
          (stan::model::rvalue(mui, "mui",
             stan::model::index_uni((1 + stan::math::modulus((i - 1), nsubj))))
          * ((1.0 + (p0 *
          stan::model::rvalue(tm, "tm", stan::model::index_uni(i)))) + ((p1 *
          stan::model::rvalue(tm, "tm", stan::model::index_uni(i))) *
          stan::model::rvalue(arm, "arm", stan::model::index_uni(i))))),
          "assigning variable muii", stan::model::index_uni(i));
        current_statement__ = 16;
        stan::model::assign(sii,
          stan::math::sqrt(((tau + (ss *
            stan::model::rvalue(tm, "tm", stan::model::index_uni(i)))) + ((sa
            * stan::model::rvalue(tm, "tm", stan::model::index_uni(i))) *
            stan::model::rvalue(arm, "arm", stan::model::index_uni(i))))),
          "assigning variable sii", stan::model::index_uni(i));
      }
      {
        current_statement__ = 23;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mui, mu0,
                         stan::math::sqrt(sigma0)));
        current_statement__ = 24;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mu0, mu, sigma));
        current_statement__ = 25;
        lp_accum__.add(stan::math::inv_gamma_lpdf<propto__>(tau, 1.0, 1.0));
        current_statement__ = 26;
        lp_accum__.add(stan::math::inv_gamma_lpdf<propto__>(sigma0, 1.0, 1.0));
        current_statement__ = 27;
        lp_accum__.add(stan::math::inv_gamma_lpdf<propto__>(sa, 1.0, 1.0));
        current_statement__ = 28;
        lp_accum__.add(stan::math::inv_gamma_lpdf<propto__>(ss, 1.0, 1.0));
        current_statement__ = 29;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(w, muii, sii));
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_ate_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      double p0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 1;
      p0 = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(-1,
             1, lp__);
      double p1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 2;
      p1 = in__.template read_constrain_lub<local_scalar_t__, jacobian__>(-1,
             1, lp__);
      Eigen::Matrix<double,-1,1> mui =
        Eigen::Matrix<double,-1,1>::Constant(nsubj,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 3;
      mui = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(nsubj);
      double mu0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 4;
      mu0 = in__.template read<local_scalar_t__>();
      double sigma0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 5;
      sigma0 = in__.template read<local_scalar_t__>();
      double sa = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 6;
      sa = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      double ss = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 7;
      ss = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
             lp__);
      double tau = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 8;
      tau = in__.template read_constrain_lb<local_scalar_t__, jacobian__>(0,
              lp__);
      Eigen::Matrix<double,-1,1> muii =
        Eigen::Matrix<double,-1,1>::Constant(N,
          std::numeric_limits<double>::quiet_NaN());
      Eigen::Matrix<double,-1,1> sii =
        Eigen::Matrix<double,-1,1>::Constant(N,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(p0);
      out__.write(p1);
      out__.write(mui);
      out__.write(mu0);
      out__.write(sigma0);
      out__.write(sa);
      out__.write(ss);
      out__.write(tau);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 18;
      for (int i = 1; i <= N; ++i) {
        current_statement__ = 15;
        stan::model::assign(muii,
          (stan::model::rvalue(mui, "mui",
             stan::model::index_uni((1 + stan::math::modulus((i - 1), nsubj))))
          * ((1.0 + (p0 *
          stan::model::rvalue(tm, "tm", stan::model::index_uni(i)))) + ((p1 *
          stan::model::rvalue(tm, "tm", stan::model::index_uni(i))) *
          stan::model::rvalue(arm, "arm", stan::model::index_uni(i))))),
          "assigning variable muii", stan::model::index_uni(i));
        current_statement__ = 16;
        stan::model::assign(sii,
          stan::math::sqrt(((tau + (ss *
            stan::model::rvalue(tm, "tm", stan::model::index_uni(i)))) + ((sa
            * stan::model::rvalue(tm, "tm", stan::model::index_uni(i))) *
            stan::model::rvalue(arm, "arm", stan::model::index_uni(i))))),
          "assigning variable sii", stan::model::index_uni(i));
      }
      if (emit_transformed_parameters__) {
        out__.write(muii);
        out__.write(sii);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
      double es_abs = std::numeric_limits<double>::quiet_NaN();
      double es_rel = std::numeric_limits<double>::quiet_NaN();
      double es0 = std::numeric_limits<double>::quiet_NaN();
      double es1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 19;
      es_rel = p1;
      current_statement__ = 20;
      es_abs = (p1 * mu0);
      current_statement__ = 21;
      es0 = (p0 * mu0);
      current_statement__ = 22;
      es1 = ((p1 + p0) * mu0);
      out__.write(es_abs);
      out__.write(es_rel);
      out__.write(es0);
      out__.write(es1);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ p0 = DUMMY_VAR__;
      current_statement__ = 1;
      p0 = in__.read<local_scalar_t__>();
      out__.write_free_lub(-1, 1, p0);
      local_scalar_t__ p1 = DUMMY_VAR__;
      current_statement__ = 2;
      p1 = in__.read<local_scalar_t__>();
      out__.write_free_lub(-1, 1, p1);
      Eigen::Matrix<local_scalar_t__,-1,1> mui =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(nsubj, DUMMY_VAR__);
      current_statement__ = 3;
      stan::model::assign(mui,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(nsubj),
        "assigning variable mui");
      out__.write(mui);
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = in__.read<local_scalar_t__>();
      out__.write(mu0);
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = in__.read<local_scalar_t__>();
      out__.write(sigma0);
      local_scalar_t__ sa = DUMMY_VAR__;
      current_statement__ = 6;
      sa = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, sa);
      local_scalar_t__ ss = DUMMY_VAR__;
      current_statement__ = 7;
      ss = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, ss);
      local_scalar_t__ tau = DUMMY_VAR__;
      current_statement__ = 8;
      tau = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, tau);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "p0", "double",
        std::vector<size_t>{});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "p1", "double",
        std::vector<size_t>{});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "mui", "double",
        std::vector<size_t>{static_cast<size_t>(nsubj)});
      current_statement__ = 4;
      context__.validate_dims("parameter initialization", "mu0", "double",
        std::vector<size_t>{});
      current_statement__ = 5;
      context__.validate_dims("parameter initialization", "sigma0", "double",
        std::vector<size_t>{});
      current_statement__ = 6;
      context__.validate_dims("parameter initialization", "sa", "double",
        std::vector<size_t>{});
      current_statement__ = 7;
      context__.validate_dims("parameter initialization", "ss", "double",
        std::vector<size_t>{});
      current_statement__ = 8;
      context__.validate_dims("parameter initialization", "tau", "double",
        std::vector<size_t>{});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ p0 = DUMMY_VAR__;
      current_statement__ = 1;
      p0 = context__.vals_r("p0")[(1 - 1)];
      out__.write_free_lub(-1, 1, p0);
      local_scalar_t__ p1 = DUMMY_VAR__;
      current_statement__ = 2;
      p1 = context__.vals_r("p1")[(1 - 1)];
      out__.write_free_lub(-1, 1, p1);
      Eigen::Matrix<local_scalar_t__,-1,1> mui =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(nsubj, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> mui_flat__;
        current_statement__ = 3;
        mui_flat__ = context__.vals_r("mui");
        current_statement__ = 3;
        pos__ = 1;
        current_statement__ = 3;
        for (int sym1__ = 1; sym1__ <= nsubj; ++sym1__) {
          current_statement__ = 3;
          stan::model::assign(mui, mui_flat__[(pos__ - 1)],
            "assigning variable mui", stan::model::index_uni(sym1__));
          current_statement__ = 3;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(mui);
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = context__.vals_r("mu0")[(1 - 1)];
      out__.write(mu0);
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = context__.vals_r("sigma0")[(1 - 1)];
      out__.write(sigma0);
      local_scalar_t__ sa = DUMMY_VAR__;
      current_statement__ = 6;
      sa = context__.vals_r("sa")[(1 - 1)];
      out__.write_free_lb(0, sa);
      local_scalar_t__ ss = DUMMY_VAR__;
      current_statement__ = 7;
      ss = context__.vals_r("ss")[(1 - 1)];
      out__.write_free_lb(0, ss);
      local_scalar_t__ tau = DUMMY_VAR__;
      current_statement__ = 8;
      tau = context__.vals_r("tau")[(1 - 1)];
      out__.write_free_lb(0, tau);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"p0", "p1", "mui", "mu0", "sigma0",
                "sa", "ss", "tau"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"muii", "sii"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::string> temp{"es_abs", "es_rel", "es0", "es1"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{},
                std::vector<size_t>{},
                std::vector<size_t>{static_cast<size_t>(nsubj)},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(N)},
             std::vector<size_t>{static_cast<size_t>(N)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{}, std::vector<size_t>{},
             std::vector<size_t>{}, std::vector<size_t>{}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "p0");
    param_names__.emplace_back(std::string() + "p1");
    for (int sym1__ = 1; sym1__ <= nsubj; ++sym1__) {
      param_names__.emplace_back(std::string() + "mui" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "mu0");
    param_names__.emplace_back(std::string() + "sigma0");
    param_names__.emplace_back(std::string() + "sa");
    param_names__.emplace_back(std::string() + "ss");
    param_names__.emplace_back(std::string() + "tau");
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "muii" + '.' +
          std::to_string(sym1__));
      }
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "sii" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      param_names__.emplace_back(std::string() + "es_abs");
      param_names__.emplace_back(std::string() + "es_rel");
      param_names__.emplace_back(std::string() + "es0");
      param_names__.emplace_back(std::string() + "es1");
    }
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "p0");
    param_names__.emplace_back(std::string() + "p1");
    for (int sym1__ = 1; sym1__ <= nsubj; ++sym1__) {
      param_names__.emplace_back(std::string() + "mui" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "mu0");
    param_names__.emplace_back(std::string() + "sigma0");
    param_names__.emplace_back(std::string() + "sa");
    param_names__.emplace_back(std::string() + "ss");
    param_names__.emplace_back(std::string() + "tau");
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "muii" + '.' +
          std::to_string(sym1__));
      }
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "sii" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      param_names__.emplace_back(std::string() + "es_abs");
      param_names__.emplace_back(std::string() + "es_rel");
      param_names__.emplace_back(std::string() + "es0");
      param_names__.emplace_back(std::string() + "es1");
    }
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"p0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"p1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mui\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(nsubj) + "},\"block\":\"parameters\"},{\"name\":\"mu0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sa\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"ss\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"muii\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"sii\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"es_abs\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es_rel\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es0\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es1\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"p0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"p1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mui\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(nsubj) + "},\"block\":\"parameters\"},{\"name\":\"mu0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sa\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"ss\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"muii\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"sii\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"es_abs\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es_rel\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es0\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es1\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((((((1 + 1) + nsubj) + 1) + 1) + 1) + 1) +
      1);
    const size_t num_transformed = emit_transformed_parameters * ((N + N));
    const size_t num_gen_quantities = emit_generated_quantities * ((((1 + 1)
      + 1) + 1));
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((((((1 + 1) + nsubj) + 1) + 1) + 1) + 1) +
      1);
    const size_t num_transformed = emit_transformed_parameters * ((N + N));
    const size_t num_gen_quantities = emit_generated_quantities * ((((1 + 1)
      + 1) + 1));
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_ate_namespace::model_ate;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_ate_namespace::profiles__;
}
#endif
#endif
