// Generated by rstantools.  Do not edit by hand.

/*
    prome is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    prome is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with prome.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_zate_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 33> locations_array__ =
  {" (found before start of program)",
  " (in 'zate', line 12, column 2 to column 18)",
  " (in 'zate', line 13, column 2 to column 11)",
  " (in 'zate', line 14, column 2 to column 11)",
  " (in 'zate', line 15, column 2 to column 11)",
  " (in 'zate', line 16, column 2 to column 14)",
  " (in 'zate', line 17, column 2 to column 27)",
  " (in 'zate', line 18, column 2 to column 25)",
  " (in 'zate', line 21, column 2 to column 25)",
  " (in 'zate', line 22, column 2 to column 25)",
  " (in 'zate', line 33, column 2 to column 14)",
  " (in 'zate', line 34, column 2 to column 14)",
  " (in 'zate', line 23, column 2 to column 48)",
  " (in 'zate', line 24, column 2 to column 70)",
  " (in 'zate', line 35, column 2 to column 15)",
  " (in 'zate', line 36, column 2 to column 19)",
  " (in 'zate', line 27, column 2 to column 27)",
  " (in 'zate', line 29, column 4 to line 30, column 59)",
  " (in 'zate', line 28, column 2 to line 30, column 59)",
  " (in 'zate', line 2, column 2 to column 17)",
  " (in 'zate', line 3, column 9 to column 10)",
  " (in 'zate', line 3, column 2 to column 18)",
  " (in 'zate', line 4, column 2 to column 19)",
  " (in 'zate', line 5, column 2 to column 18)",
  " (in 'zate', line 6, column 9 to column 10)",
  " (in 'zate', line 6, column 2 to column 15)",
  " (in 'zate', line 7, column 9 to column 10)",
  " (in 'zate', line 7, column 2 to column 15)",
  " (in 'zate', line 8, column 2 to column 20)",
  " (in 'zate', line 9, column 9 to column 11)",
  " (in 'zate', line 9, column 12 to column 13)",
  " (in 'zate', line 9, column 2 to column 17)",
  " (in 'zate', line 12, column 9 to column 11)"};
#include <stan_meta_header.hpp>
class model_zate final : public model_base_crtp<model_zate> {
private:
  int N;
  Eigen::Matrix<double,-1,1> group_data__;
  double r1;
  int rz;
  Eigen::Matrix<double,-1,1> w0_data__;
  Eigen::Matrix<double,-1,1> w1_data__;
  double tau;
  Eigen::Matrix<double,-1,-1> z_data__;
  Eigen::Map<Eigen::Matrix<double,-1,1>> group{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> w0{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> w1{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,-1>> z{nullptr, 0, 0};
public:
  ~model_zate() {}
  model_zate(stan::io::var_context& context__, unsigned int
             random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_zate_namespace::model_zate";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 19;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 19;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 19;
      stan::math::check_greater_or_equal(function__, "N", N, 0);
      current_statement__ = 20;
      stan::math::validate_non_negative_index("group", "N", N);
      current_statement__ = 21;
      context__.validate_dims("data initialization", "group", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      group_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                       std::numeric_limits<double>::quiet_NaN());
      new (&group)
        Eigen::Map<Eigen::Matrix<double,-1,1>>(group_data__.data(), N);
      {
        std::vector<local_scalar_t__> group_flat__;
        current_statement__ = 21;
        group_flat__ = context__.vals_r("group");
        current_statement__ = 21;
        pos__ = 1;
        current_statement__ = 21;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 21;
          stan::model::assign(group, group_flat__[(pos__ - 1)],
            "assigning variable group", stan::model::index_uni(sym1__));
          current_statement__ = 21;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 22;
      context__.validate_dims("data initialization", "r1", "double",
        std::vector<size_t>{});
      r1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 22;
      r1 = context__.vals_r("r1")[(1 - 1)];
      current_statement__ = 22;
      stan::math::check_greater_or_equal(function__, "r1", r1, 0);
      current_statement__ = 23;
      context__.validate_dims("data initialization", "rz", "int",
        std::vector<size_t>{});
      rz = std::numeric_limits<int>::min();
      current_statement__ = 23;
      rz = context__.vals_i("rz")[(1 - 1)];
      current_statement__ = 23;
      stan::math::check_greater_or_equal(function__, "rz", rz, 0);
      current_statement__ = 24;
      stan::math::validate_non_negative_index("w0", "N", N);
      current_statement__ = 25;
      context__.validate_dims("data initialization", "w0", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      w0_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                    std::numeric_limits<double>::quiet_NaN());
      new (&w0) Eigen::Map<Eigen::Matrix<double,-1,1>>(w0_data__.data(), N);
      {
        std::vector<local_scalar_t__> w0_flat__;
        current_statement__ = 25;
        w0_flat__ = context__.vals_r("w0");
        current_statement__ = 25;
        pos__ = 1;
        current_statement__ = 25;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 25;
          stan::model::assign(w0, w0_flat__[(pos__ - 1)],
            "assigning variable w0", stan::model::index_uni(sym1__));
          current_statement__ = 25;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 26;
      stan::math::validate_non_negative_index("w1", "N", N);
      current_statement__ = 27;
      context__.validate_dims("data initialization", "w1", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      w1_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                    std::numeric_limits<double>::quiet_NaN());
      new (&w1) Eigen::Map<Eigen::Matrix<double,-1,1>>(w1_data__.data(), N);
      {
        std::vector<local_scalar_t__> w1_flat__;
        current_statement__ = 27;
        w1_flat__ = context__.vals_r("w1");
        current_statement__ = 27;
        pos__ = 1;
        current_statement__ = 27;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 27;
          stan::model::assign(w1, w1_flat__[(pos__ - 1)],
            "assigning variable w1", stan::model::index_uni(sym1__));
          current_statement__ = 27;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 28;
      context__.validate_dims("data initialization", "tau", "double",
        std::vector<size_t>{});
      tau = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 28;
      tau = context__.vals_r("tau")[(1 - 1)];
      current_statement__ = 28;
      stan::math::check_greater_or_equal(function__, "tau", tau, 0);
      current_statement__ = 29;
      stan::math::validate_non_negative_index("z", "rz", rz);
      current_statement__ = 30;
      stan::math::validate_non_negative_index("z", "N", N);
      current_statement__ = 31;
      context__.validate_dims("data initialization", "z", "double",
        std::vector<size_t>{static_cast<size_t>(rz), static_cast<size_t>(N)});
      z_data__ = Eigen::Matrix<double,-1,-1>::Constant(rz, N,
                   std::numeric_limits<double>::quiet_NaN());
      new (&z) Eigen::Map<Eigen::Matrix<double,-1,-1>>(z_data__.data(), rz,
        N);
      {
        std::vector<local_scalar_t__> z_flat__;
        current_statement__ = 31;
        z_flat__ = context__.vals_r("z");
        current_statement__ = 31;
        pos__ = 1;
        current_statement__ = 31;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 31;
          for (int sym2__ = 1; sym2__ <= rz; ++sym2__) {
            current_statement__ = 31;
            stan::model::assign(z, z_flat__[(pos__ - 1)],
              "assigning variable z", stan::model::index_uni(sym2__),
              stan::model::index_uni(sym1__));
            current_statement__ = 31;
            pos__ = (pos__ + 1);
          }
        }
      }
      current_statement__ = 32;
      stan::math::validate_non_negative_index("beta", "rz", rz);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = rz + 1 + 1 + 1 + 1 + 1 + 1;
  }
  inline std::string model_name() const final {
    return "model_zate";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_zate_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(rz, DUMMY_VAR__);
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(rz);
      local_scalar_t__ es0 = DUMMY_VAR__;
      current_statement__ = 2;
      es0 = in__.template read<local_scalar_t__>();
      local_scalar_t__ es1 = DUMMY_VAR__;
      current_statement__ = 3;
      es1 = in__.template read<local_scalar_t__>();
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = in__.template read<local_scalar_t__>();
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = in__.template read<local_scalar_t__>();
      local_scalar_t__ sig_active = DUMMY_VAR__;
      current_statement__ = 6;
      sig_active = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      local_scalar_t__ sig_sham = DUMMY_VAR__;
      current_statement__ = 7;
      sig_sham = in__.template read_constrain_lb<local_scalar_t__,
                   jacobian__>(0, lp__);
      local_scalar_t__ sigma_t0 = DUMMY_VAR__;
      local_scalar_t__ sigma_t1 = DUMMY_VAR__;
      current_statement__ = 12;
      sigma_t0 = stan::math::sqrt((((tau * tau) / r1) + (sig_sham *
                   sig_sham)));
      current_statement__ = 13;
      sigma_t1 = stan::math::sqrt(((((tau * tau) / r1) + (sig_active *
                   sig_active)) + (sig_sham * sig_sham)));
      current_statement__ = 8;
      stan::math::check_greater_or_equal(function__, "sigma_t0", sigma_t0, 0);
      current_statement__ = 9;
      stan::math::check_greater_or_equal(function__, "sigma_t1", sigma_t1, 0);
      {
        current_statement__ = 16;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(w0, mu0, sigma0));
        current_statement__ = 18;
        for (int i = 1; i <= N; ++i) {
          current_statement__ = 17;
          lp_accum__.add(stan::math::normal_lpdf<propto__>(
                           stan::model::rvalue(w1, "w1",
                             stan::model::index_uni(i)),
                           ((stan::model::rvalue(w0, "w0",
                               stan::model::index_uni(i)) * (es0 + (es1 *
                           stan::model::rvalue(group, "group",
                             stan::model::index_uni(i))))) +
                           stan::math::multiply(
                             stan::model::rvalue(z, "z",
                               stan::model::index_uni(i)), beta)), ((sigma_t0
                           * (1 -
                           stan::model::rvalue(group, "group",
                             stan::model::index_uni(i)))) + (sigma_t1 *
                           stan::model::rvalue(group, "group",
                             stan::model::index_uni(i))))));
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_zate_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<double,-1,1> beta =
        Eigen::Matrix<double,-1,1>::Constant(rz,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(rz);
      double es0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 2;
      es0 = in__.template read<local_scalar_t__>();
      double es1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 3;
      es1 = in__.template read<local_scalar_t__>();
      double mu0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 4;
      mu0 = in__.template read<local_scalar_t__>();
      double sigma0 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 5;
      sigma0 = in__.template read<local_scalar_t__>();
      double sig_active = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 6;
      sig_active = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      double sig_sham = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 7;
      sig_sham = in__.template read_constrain_lb<local_scalar_t__,
                   jacobian__>(0, lp__);
      double sigma_t0 = std::numeric_limits<double>::quiet_NaN();
      double sigma_t1 = std::numeric_limits<double>::quiet_NaN();
      out__.write(beta);
      out__.write(es0);
      out__.write(es1);
      out__.write(mu0);
      out__.write(sigma0);
      out__.write(sig_active);
      out__.write(sig_sham);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 12;
      sigma_t0 = stan::math::sqrt((((tau * tau) / r1) + (sig_sham *
                   sig_sham)));
      current_statement__ = 13;
      sigma_t1 = stan::math::sqrt(((((tau * tau) / r1) + (sig_active *
                   sig_active)) + (sig_sham * sig_sham)));
      current_statement__ = 8;
      stan::math::check_greater_or_equal(function__, "sigma_t0", sigma_t0, 0);
      current_statement__ = 9;
      stan::math::check_greater_or_equal(function__, "sigma_t1", sigma_t1, 0);
      if (emit_transformed_parameters__) {
        out__.write(sigma_t0);
        out__.write(sigma_t1);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
      double es_abs = std::numeric_limits<double>::quiet_NaN();
      double es_rel = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 14;
      es_rel = es1;
      current_statement__ = 15;
      es_abs = (es1 * mu0);
      out__.write(es_abs);
      out__.write(es_rel);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(rz, DUMMY_VAR__);
      current_statement__ = 1;
      stan::model::assign(beta,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(rz),
        "assigning variable beta");
      out__.write(beta);
      local_scalar_t__ es0 = DUMMY_VAR__;
      current_statement__ = 2;
      es0 = in__.read<local_scalar_t__>();
      out__.write(es0);
      local_scalar_t__ es1 = DUMMY_VAR__;
      current_statement__ = 3;
      es1 = in__.read<local_scalar_t__>();
      out__.write(es1);
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = in__.read<local_scalar_t__>();
      out__.write(mu0);
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = in__.read<local_scalar_t__>();
      out__.write(sigma0);
      local_scalar_t__ sig_active = DUMMY_VAR__;
      current_statement__ = 6;
      sig_active = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, sig_active);
      local_scalar_t__ sig_sham = DUMMY_VAR__;
      current_statement__ = 7;
      sig_sham = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, sig_sham);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "beta", "double",
        std::vector<size_t>{static_cast<size_t>(rz)});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "es0", "double",
        std::vector<size_t>{});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "es1", "double",
        std::vector<size_t>{});
      current_statement__ = 4;
      context__.validate_dims("parameter initialization", "mu0", "double",
        std::vector<size_t>{});
      current_statement__ = 5;
      context__.validate_dims("parameter initialization", "sigma0", "double",
        std::vector<size_t>{});
      current_statement__ = 6;
      context__.validate_dims("parameter initialization", "sig_active",
        "double", std::vector<size_t>{});
      current_statement__ = 7;
      context__.validate_dims("parameter initialization", "sig_sham",
        "double", std::vector<size_t>{});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(rz, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> beta_flat__;
        current_statement__ = 1;
        beta_flat__ = context__.vals_r("beta");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= rz; ++sym1__) {
          current_statement__ = 1;
          stan::model::assign(beta, beta_flat__[(pos__ - 1)],
            "assigning variable beta", stan::model::index_uni(sym1__));
          current_statement__ = 1;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(beta);
      local_scalar_t__ es0 = DUMMY_VAR__;
      current_statement__ = 2;
      es0 = context__.vals_r("es0")[(1 - 1)];
      out__.write(es0);
      local_scalar_t__ es1 = DUMMY_VAR__;
      current_statement__ = 3;
      es1 = context__.vals_r("es1")[(1 - 1)];
      out__.write(es1);
      local_scalar_t__ mu0 = DUMMY_VAR__;
      current_statement__ = 4;
      mu0 = context__.vals_r("mu0")[(1 - 1)];
      out__.write(mu0);
      local_scalar_t__ sigma0 = DUMMY_VAR__;
      current_statement__ = 5;
      sigma0 = context__.vals_r("sigma0")[(1 - 1)];
      out__.write(sigma0);
      local_scalar_t__ sig_active = DUMMY_VAR__;
      current_statement__ = 6;
      sig_active = context__.vals_r("sig_active")[(1 - 1)];
      out__.write_free_lb(0, sig_active);
      local_scalar_t__ sig_sham = DUMMY_VAR__;
      current_statement__ = 7;
      sig_sham = context__.vals_r("sig_sham")[(1 - 1)];
      out__.write_free_lb(0, sig_sham);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"beta", "es0", "es1", "mu0", "sigma0",
                "sig_active", "sig_sham"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"sigma_t0", "sigma_t1"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::string> temp{"es_abs", "es_rel"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{static_cast<
                                                                    size_t>(
                                                                    rz)},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}, std::vector<size_t>{}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{}, std::vector<size_t>{}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{}, std::vector<size_t>{}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= rz; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "es0");
    param_names__.emplace_back(std::string() + "es1");
    param_names__.emplace_back(std::string() + "mu0");
    param_names__.emplace_back(std::string() + "sigma0");
    param_names__.emplace_back(std::string() + "sig_active");
    param_names__.emplace_back(std::string() + "sig_sham");
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma_t0");
      param_names__.emplace_back(std::string() + "sigma_t1");
    }
    if (emit_generated_quantities__) {
      param_names__.emplace_back(std::string() + "es_abs");
      param_names__.emplace_back(std::string() + "es_rel");
    }
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= rz; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "es0");
    param_names__.emplace_back(std::string() + "es1");
    param_names__.emplace_back(std::string() + "mu0");
    param_names__.emplace_back(std::string() + "sigma0");
    param_names__.emplace_back(std::string() + "sig_active");
    param_names__.emplace_back(std::string() + "sig_sham");
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma_t0");
      param_names__.emplace_back(std::string() + "sigma_t1");
    }
    if (emit_generated_quantities__) {
      param_names__.emplace_back(std::string() + "es_abs");
      param_names__.emplace_back(std::string() + "es_rel");
    }
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(rz) + "},\"block\":\"parameters\"},{\"name\":\"es0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"es1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sig_active\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sig_sham\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma_t0\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"sigma_t1\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"es_abs\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es_rel\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(rz) + "},\"block\":\"parameters\"},{\"name\":\"es0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"es1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma0\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sig_active\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sig_sham\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma_t0\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"sigma_t1\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"es_abs\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"},{\"name\":\"es_rel\",\"type\":{\"name\":\"real\"},\"block\":\"generated_quantities\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((((((rz + 1) + 1) + 1) + 1) + 1) + 1);
    const size_t num_transformed = emit_transformed_parameters * ((1 + 1));
    const size_t num_gen_quantities = emit_generated_quantities * ((1 + 1));
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((((((rz + 1) + 1) + 1) + 1) + 1) + 1);
    const size_t num_transformed = emit_transformed_parameters * ((1 + 1));
    const size_t num_gen_quantities = emit_generated_quantities * ((1 + 1));
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_zate_namespace::model_zate;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_zate_namespace::profiles__;
}
#endif
#endif
